
'      this program creates an example model


'      We define the directory 
'      this has to be adapted to your specifications

cd "c:\users\jean louis brillet\documents\eviews\book_africa\afsud"

'      The output (estimations, tests) will also be directed to a text file
'       Its name is _mod_afs.txt

output(t) _model_afs

'       We start from the data file data_1
'       We first save it under the name mod_afs
'       But as usual, we must avoid having other versions open at the same time
'       We afsd close statements as a precaution
'        
close data_afs.wf1
close model_afs.wf1
open data_afs.wf1
wfsave model_afs
pageselect model

'       We set the sample to maximum
'        The workfile dimension

smpl 1960 2012

'       We eliminate the a_ prefix
'       We do not need this identifier here
'       As we are working with a single country

group g_a a_*
for !i=1 to g_a.@count
%1=g_a.@seriesname(!i)

'    We use the namle starting at the third character
 
%2=@mid(%1,3)
series {%2}={%1}
next 

'      We cannot use scalars in groups (until EVIews 8)

scalar r_vat0=a_r_vat0
scalar r_tar0=a_r_tar0
scalar r_tarx0=a_r_tarx0

'     We include a program associating definitions with model series.

include def_afs

'      The forecasts will use long term growth rates
'      We shall define them now
'      But they will only apply beyond the last period
'      for which data is available
'      So they will affect neither estimations nor computations

'      txq : growth rates of quantities at constant prices (at country level)
'      txp : growth rates of populations (numbers of persons)
'      txp : growth rates of deflators

'      Actually by using the following growth rates
'      the growth rates will not take round vues
'      but the Dlog of the variables will
'      including the results of all multiplications and divisions

scalar txq=0.05
scalar txn=0.01
scalar txp=0.06

'   ==============================================

'    creating the model

'   ==============================================


'     creating a blank model

delete(noerr) _mod_afs
model _mod_afs 

'    We create a scalar to represent the function f 

scalar f

smpl 1962 2012

'==============================
'     production block
'==============================

_mod_afs.append GDPM=FD+X-M
_mod_afs.append Q=GDPM-r_vat0*FD/(1+r_vat0)

'---  estimating capacity -----------------------------------------------

_mod_afs.append cap=f*(k+lf+t)
genr ur=1
_mod_afs.append UR=Q/CAP 

'---  estimating employment -----------------------------------------------

_mod_afs.append lf=f*(q+t) 
_mod_afs.append lw=lf*r_lw
_mod_afs.append LT=LF+lg 
_mod_afs.append lp=Q/LF 

'---  estimating investment -----------------------------------------------

_mod_afs.append ip=f*(q+ur) 
_mod_afs.append k=k(-1)*(1-rdep)+ip 

'---  estimating the change in inventories -----------------------------------------------

_mod_afs.append ic=f*(q)

'    ---- estimating the actual work force ------------------------------------------------------=

_mod_afs.append popac=f*(lt+pop1564) 
_mod_afs.append UN=POPAC-LT
_mod_afs.append UNR=UN/POPAC*100

'=========================================================
'     price block
'=========================================================

_mod_afs.append UWC=WR*(1+r_scf)/LP  

'    -----estimating the GDP deflator--------------------------------------------------

_mod_afs.append pq=f*(UWC+ur) 
_mod_afs.append PP=(PQ+tc*PFDXT)/(1+tc) 
genr (1+res_fdv)*(coh*pcoh+ip*pip+ih*pip+ic*pfd+cog*pcog+pig*ig)=fdv
_mod_afs.append FDV=(1+res_fdv)*(coh*pcoh+ip*pip+ih*pip+ic*pfd+cog*pcog+pig*ig)
_mod_afs.append FDLV=GDPMV-XV
_mod_afs.append FDL=GDPM-X
_mod_afs.append PFDL=FDLV/FDL 
_mod_afs.append PFD=(FDLV+MV)/(FDL+M)
_mod_afs.append PFDXT=PFD*(1+r_vat0)/(1+r_vat) 
_mod_afs.append pcoh=r_pcoh*PFD
_mod_afs.append pip=r_pip*PFD
_mod_afs.append PIG=r_pig*PFD 

'    ----- estimating the wage rate -----------------------------------------------------

_mod_afs.append wr=f*(pcoh+uwc+pq+unr)
scalar c_cost
_mod_afs.append cost=(wr*lf*(1+r_scf)+c_cost*pip*k(-1))/q

'      -----estimating the import price--------------------------------------------------

_mod_afs.append pm=f*(pp+ppx+er) 

'       ----estimating the export price--------------------------------------------------

_mod_afs.append px=f*(pp+px+er) 

scalar c_er=1
_mod_afs.append dlog(ER)=(c_er=1)*dlog(erx)+(c_er=2)*dlog(pcoh)
scalar c_irs=2
_mod_afs.append IRS=(c_irs=1)*IRSX+(c_IRS=2)*(IRSR+100*@pchy(pcoh))+(c_IRS=3)*(150*@pchy(pcoh)+50*(UR-urd)/urd+irst)
_mod_afs.append IRL=@movav(IRS,4)+IRL_EC 
scalar c_ir=0.5
_mod_afs.append IR=c_ir*IRS+(1-c_ir)*IRL+ir_eC
scalar c_irm=0.8
_mod_afs.append IRM=c_irm*IRM(-1)+(1-c_irm)*IR
_mod_afs.append relc=wr*(1+r_scf)/pip/(ir/100-@pchy(pcoh)+rdep)

'=========================================================
'   households block
'=========================================================

_mod_afs.append REM=REMX*ER
_mod_afs.append REVX=r_revx*PFD
_mod_afs.append SOCB=socbr*pcoh*popt
_mod_afs.append WageG=WR*lg
_mod_afs.append Wage=WageF+WageG
_mod_afs.append SCW=r_scw*Wage
_mod_afs.append HI=Wage-SCW+REVQ+REVX+SOCB+rem
_mod_afs.append ICT=r_ict*HI   '  *****rem : lagged???
_mod_afs.append HDI=HI-ICT
_mod_afs.append HRDI=HDI/pcoh
_mod_afs.append IH=R_IH*HRDI

'    -----estimating household consumption-----------------------------------------------

_mod_afs.append coh=f*(hrdi+unr+irs+pcoh) 

'=========================================================
'    firms block
'=========================================================

_mod_afs.append Qv=PQ*Q
_mod_afs.append GDPMv=Qv+VAT
_mod_afs.append pgdpm=GDPMv/GDPM
_mod_afs.append WageF=WR*lw
_mod_afs.append SUBS=r_subs*Qv
_mod_afs.append MARG=PQ*Q*(1+r_subs-r_oit)-Wagef*(1+r_scf)
_mod_afs.append RMARG=MARG/Qv
_mod_afs.append IFP=(marg-revq)*r_ifp
_mod_afs.append NIF=NIF(-1)*IRM/IRM(-1)-IR/100*FCAPF+nif_er*qv
_mod_afs.append REVQ=R_REVQ*QV
_mod_afs.append PROF=MARG-REVQ-IFP-NIF
_mod_afs.append RPROF=PROF/(PFD*K(-1))
_mod_afs.append RPROB=MARG/(PFD*K(-1))
_mod_afs.append FCAPF=PROF-pip*I-PFD*IC
_mod_afs.append I=IP+IH+IG

'=========================================================
'     external trade block
'=========================================================

_mod_afs.append PMT=PM*(1+r_tar)/(1+r_tar0)
_mod_afs.append COMPM=PMT/PP 
_mod_afs.append FD=COH+IP+IH+IC+cog+IG+fdxr*Q
_mod_afs.append CI=TC*Q
_mod_afs.append TD=FD+CI

'    ----estimating imports---------------------------------------------

_mod_afs.append m=f*(td+compm+ur)

_mod_afs.append COMPX=PX*(1+r_tarx)/(1+r_tarx0)/(PPX*ER)

'    ----estimating exports---------------------------------------------

_mod_afs.append x=f*(wd+compx+ur)
_mod_afs.append Mv=PM*M
_mod_afs.append Xv=PX*X
_mod_afs.append RCval=Xv/Mv
_mod_afs.append RCVOL=X/M
_mod_afs.append TTRAD=PX/PM
_mod_afs.append TRB=Xv-Mv
scalar c_nix=0.5
_mod_afs.append NIXD=NIXD(-1)*IRM/IRM(-1)-IR/100*c_nix*TRB+nixd_ec*(xv+mv)
_mod_afs.append NIXX=NIXX(-1)*IRMX/IRMX(-1)*(er/er(-1))-IRX/100*((1-c_nix)*TRB) +nixx_ec*(xv+mv)
_mod_afs.append NIX=NIXD+NIXX
_mod_afs.append FCAPX=TRB-NIX

'=========================================================
'     State budget block
'=========================================================
'
_mod_afs.append VAT=r_vat*PFD*FD/(1+r_vat)
_mod_afs.append SCF=r_scf*Wagef
_mod_afs.append OIT=r_oit*(Qv-oit)
_mod_afs.append TAR=r_tar*Mv
_mod_afs.append Scg=R_Scg*WAGEG
_mod_afs.append REVG=SCF+Scg+SCW+OIT+IFP+ICT+VAT+TAR+r_revg*Qv
_mod_afs.append IGV=IG*PIG
_mod_afs.append PCOG=PFD*R_PCOG
_mod_afs.append cogV=cog*Pcog
_mod_afs.append FDGV=cogV+IGV
_mod_afs.append NIG=NIG(-1)*IRM/IRM(-1)-IR/100*FCAPG+nig_er*qv
_mod_afs.append EXPG=FDGV+WAGEG+SUBS+SOCB+NIG+Scg+r_expg*Qv
_mod_afs.append FCAPG=REVG-EXPG
_mod_afs.append FCAPGP=100*FCAPG/gdpmv

'     We check the residuals

_mod_afs.append assign @all _c

smpl 2000 2012

'     We create groups for the endogenous and exogenous elements

_mod_afs.makegroup(a,n) _g_vendog @endog
_mod_afs.makegroup(a,n) _g_vexog @exog 

'     We solve the model in "fit" mode

'     The computation uses only historical values

_mod_afs.append assign @all _c
_mod_afs.solve(d=f) 

'      We compute the differences with historical values
'      For identities it should be zero
'      For behavioral the result is irrelevant
'      but being able to compute the equation means thjat we can estimate it

for !i=1 to _g_vendog.@count
%1=_g_vendog.@seriesname(!i)
genr dc_{%1}={%1}-{%1}_c
genr pc_{%1}=100*dc_{%1}/({%1}+({%1}=0))
next
smpl 1960 2020
save model_afs


