
'      this program creates an example model


'      We define the directory 
'      this has to be adapted to your specifications

cd "c:\users\jean louis brillet\documents\eviews\book_africa2\afsud"

'      The output (estimations, tests) will also be directed to a text file
'       Its name is _mod_afs.txt

output(t) _model_afs

'       We start from the data file data_1
'       We first save it under the name mod_afs
'       But as usual, we must avoid having other versions open at the same time
'       We afsd close statements as a precaution
'        
close data_afs.wf1
close model_afs.wf1
open data_afs.wf1
wfsave model_afs
pageselect model

'     creating a blank model

delete(noerr) _mod_afs
model _mod_afs

'       We set the sample to maximum
'        The workfile dimension

smpl 1960 2012

'       We eliminate the f_ prefix
'       We do not need this identifier
'       As we are working with a single country

group g_a a_*
for !i=1 to g_a.@count
%1=g_a.@seriesname(!i)
%2=@mid(%1,3)
series {%2}={%1}
next 

include def_afs

'      The forecasts will use long term growth rates
'      We shall define them now
'      But they will only apply beyond the last period
'      for which data is available
'      So they will affect neither estimations nor computations

'      txq : growth rates of quantities at constant prices (at country level)
'      txp : growth rates of populations (numbers of persons)
'      txp : growth rates of deflators

'      Actually by using the following growth rates
'      the growth rates will not take round vues
'      but the Dlog of the variables will
'      including the results of all multiplications and divisions

scalar txq=0.05
scalar txn=0.01
scalar txp=0.06

'   ==============================================

'    We start with the estimations

'   ==============================================

'---  estimating capacity -----------------------------------------------

smpl 1996 2012
genr cap=q
coef(10) c_cap
vector(10) p_cap  
equation _eq_cap.ls(p) log(cap)=(1-c_cap(1))*log(k(-1))+c_cap(1)*log(lf)+c_cap(2)+c_cap(3)*(t-2012)*(t<=2012)+c_cap(1)*log((1+txq)/(1+txn))*(t-2012)*(t>=2012)
'_mod_afs.append log(cap)=(1-c_cap(1))*log(k(-1))+c_cap(1)*log(lf)+c_cap(2)+c_cap(3)*(t-2012)*(t<=2012)+c_cap(1)*log((1+txq)/(1+txn))*(t-2012)*(t>=2012)
_mod_afs.merge _eq_cap
genr log(ur)=resid
genr cap=q/ur

'---  estimating investment -----------------------------------------------

smpl 1980 2012  
coef(10) c_ip
vector(10) p_ip 
genr ip_ec=0
equation _eq_ip.ls(p) ip/k(-1)=c_ip(1)*ip(-1)/k(-2)+c_ip(2)*@pch(q)+c_ip(3)*log(q/cap)+c_ip(4)+ip_ec
'_mod_afs.append ip/k(-1)=c_ip(1)*ip(-1)/k(-2)+c_ip(2)*@pch(q)+c_ip(3)*log(q/cap)+c_ip(4)+ip_ec
_mod_afs.merge _eq_ip
genr ip_ec=resid

'---  estimating employment -----------------------------------------------

coef(10) c_lpt
vector(10) p_lpt
coef(10) c_lf
vector(10) p_lf
smpl @first 2012
genr ec_lp=0
genr lpt=q/lf
equation _eq_lpt.ls(p) log(lpt)=c_lpt(1)+c_lpt(2)*(t-2012)*(t<=2012)+log((1+txq)/(1+txn))*(t-2012)*(t>=2012)+c_lpt(3)*(t-1999)*(t<=1999) 
_mod_afs.append  log(lpt)=c_lpt(1)+c_lpt(2)*(t-2012)*(t<=2012)+log((1+txq)/(1+txn))*(t-2012)*(t>=2012)+c_lpt(3)*(t-1999)*(t<=1999) 
genr log(lpt)=c_lpt(1)+c_lpt(2)*(t-2012)*(t<=2012)+log((1+txq)/(1+txn))*(t-2012)*(t>=2012)+c_lpt(3)*(t-1999)*(t<=1999) 
genr lfd=q/lpt
genr lf_ec=0 

equation _eq_lf.ls(p) dlog(lf)=c_lf(1)*dlog(lfd)+c_lf(2)*log(lfd(-1)/lf(-1))+c_lf(3)+c_lf(4)*((t=1994)+(t=1995))+lf_ec
'_mod_afs.append dlog(lf)=c_lf(1)*dlog(lfd)+c_lf(2)*log(lfd(-1)/lf(-1))+c_lf(3)+c_lf(4)*((t=1994)+(t=1995))+lf_ec
_mod_afs.merge _eq_lf
genr lf_ec=resid
p_lpt(1)=c_lpt(1)
p_lpt(2)=c_lpt(2)

'---  estimating the change in inventories -----------------------------------------------
'showerr_ic
coef(10) c_ic
vector(10) p_ic
smpl 1962 2012
genr ic_ec=0
smpl 1962 2012 

equation _eq_ic.ls(p) ic/q(-1)=c_ic(1)*c_ic(2)*@pchy(q)+(1-c_ic(1))*ic(-1)/q(-2)+ic_ec 
'_mod_afs.append ic/q(-1)=c_ic(1)*c_ic(2)*@pchy(q)+(1-c_ic(1))*ic(-1)/q(-2)+ic_ec 
_mod_afs.merge _eq_ic
genr ic_ec=resid

 

'    ---- estimating the actual work force ------------------------------------------------------

'showerr_popac
coef(10) c_popac
vector(10) p_popac

'      Special case : we want to set the vue of a coefficient and estimate the rest

'      We create a normal vector in the same way as coefficients
'       with "p" instead of "c"

'      We just have to replace "c" by "p" in the equation
'      and give our vue to the corresponding "p" element

'      This makes it easy to switch the definition

'      Here this applies to the third coefficient
'      with the vue 0.6
 
smpl 1962 2012
genr popac_ec=0
smpl 1996 2012 
equation _eq_popac.ls(p) d(popac)/pop1564(-1)=c_popac(1)*d(lt)/pop1564(-1)+c_popac(2)*d(pop1564)/pop1564(-1)-c_popac(3)*(popac(-1)/pop1564(-1)-c_popac(4)*lt(-1)/pop1564(-1)-c_popac(5))+popac_ec
'_mod_afs.append d(popac)/pop1564(-1)=c_popac(1)*d(lt)/pop1564(-1)+c_popac(2)*d(pop1564)/pop1564(-1)-c_popac(3)*(popac(-1)/pop1564(-1)-c_popac(4)*lt(-1)/pop1564(-1)-c_popac(5))+popac_ec
_mod_afs.merge _eq_popac
genr popac_ec=resid 

'    Managing the residuals is also special
'    as the equation uses an AR process

'    We start by storing the RESID variable

genr resid_popac=resid

'    ----------------------------------------------------------

'    estimating the GDP deflator

'showerr_pq
smpl 1962 2012
scalar c_cost=0.05
genr cost=(wr*lf*(1+r_scf)+c_cost*pip*k(-1))/q
genr costw=(wr*lf*(1+r_scf))/q
coef(10) c_pq
vector(10) p_pq
genr pq_ec=0
smpl 1962 2012 
p_pq(2)=0.00
p_pq(3)=0.10
equation _eq_pq.ls(p) dlog(pq)=c_pq(1)*dlog(costw)+p_pq(2)*dlog(q/cap)-p_pq(3)*(log(pq(-1)/costw(-1))-p_pq(2)*log(q(-1)/cap(-1)))+c_pq(5)+pq_ec
'_mod_afs.append dlog(pq)=c_pq(1)*dlog(costw)+p_pq(2)*dlog(q/cap)-c_pq(3)*(log(pq(-1)/costw(-1))-p_pq(2)*log(q(-1)/cap(-1)))+c_pq(5)+pq_ec
_mod_afs.merge _eq_pq
genr pq_ec=resid 

'    ----- estimating the wage rate -----------------------------------------------------

'      This time we apply cointegration
'      we would like to use this technique more often
'      but we did not find another working case

'showerr_wr 
coef(10) c_wr
vector(10) p_wr

'    we have to create an intermediary variable
 
smpl 1962 2012
genr wr_ec=0 
smpl 1962 2012 
p_wr(3)=-0.10
p_wr(4)=0.5
equation _eq_wr.ls(p) DLOG(WR)=C_WR(1)*DLOG(PCOH)+C_WR(2)*LOG(UNR)+p_WR(3)*(LOG(COSTW(-1))-p_wr(4)*LOG(PCOH(-1))-(1-p_wr(4))*LOG(PQ(-1)))+C_WR(5)
'_mod_afs.append DLOG(WR)=C_WR(1)*DLOG(PCOH)+C_WR(2)*LOG(UNR)+C_WR(3)*(LOG(COSTW(-1))-p_wr(4)*LOG(PCOH(-1))-(1-p_wr(4))*LOG(PQ(-1)))+C_WR(5)+wr_ec
_mod_afs.merge _eq_wr
genr wr_ec=resid 

'    ----------------------------------------------------------


'    estimating the import price

coef(10) c_pm
vector(10) p_pm
smpl 1993 2012
genr pm_ec=0
smpl @all 

equation _eq_pm.ls(p) dlog(pm)=c_pm(1)*dlog(pp)+c_pm(2)*dlog(ppx*er)-c_pm(3)*(log(pm(-1))-c_pm(4)*log(pp(-1))-(1-c_pm(4))*log(ppx(-1)*er(-1)))+c_pm(5)*(t-2012)*(t<=2012)+c_pm(6) +pm_ec
'_mod_afs.append dlog(pm)=c_pm(1)*dlog(pp)+c_pm(2)*dlog(ppx*er)-c_pm(3)*(log(pm(-1))-c_pm(4)*log(pp(-1))-(1-c_pm(4))*log(ppx(-1)*er(-1)))+c_pm(5)*(t-2012)*(t<=2012)+c_pm(6) +pm_ec
_mod_afs.merge _eq_pm 
genr pm_ec=resid 

'    ----------------------------------------------------------


'    estimating the export price


'showerr_px
coef(10) c_px
vector(10) p_px
smpl 1993 2012
genr px_ec=0 

p_px(4)=0.20
equation _eq_px.ls(p) dlog(px)=c_px(1)*dlog(pp)+c_px(2)*dlog(ppx*er)-c_px(3)*(log(px(-1))-p_px(4)*log(pp(-1))-(1-p_px(4))*log(ppx(-1)*er(-1)))+c_px(5)*(t-2012)*(t<=2012)+c_px(6)+px_ec
'_mod_afs.append dlog(px)=c_px(1)*dlog(pp)+c_px(2)*dlog(ppx*er)-c_px(3)*(log(px(-1))-p_px(4)*log(pp(-1))-(1-p_px(4))*log(ppx(-1)*er(-1)))+c_px(5)*(t-2012)*(t<=2012)+c_px(6)+px_ec
_mod_afs.merge _eq_px
genr ppx_ec=resid 

'    ----------------------------------------------------------

'    estimating household consumption

'showerr_coh
coef(10) c_coh
vector(10) p_coh
smpl 1962 2012
genr coh_ec=0
smpl 1996 2012

equation _eq_coh.ls(p) dlog(coh)=c_coh(1)+c_coh(2)*(t-2012)*(t<=2012)+c_coh(3)*dlog(hrdi)+c_coh(4)*log(coh(-1)/hrdi(-1))+c_coh(5)*d(unr)+c_coh(6)*(irs-100*@pch(pcoh))+c_coh(7)*dlog(coh(-1))+coh_ec
'_mod_afs.append dlog(coh)=c_coh(1)+c_coh(2)*(t-2012)*(t<=2012)+c_coh(3)*dlog(hrdi)+c_coh(4)*log(coh(-1)/hrdi(-1))+c_coh(5)*d(unr)+c_coh(6)*(irs-100*@pch(pcoh))+coh_ec
_mod_afs.merge _eq_coh
genr coh_ec=resid 


'    ----------------------------------------------------------

'    estimating imports

'showerr_m
coef(10) c_m
vector(10) p_m
smpl 1962 2012
genr m_ec=0
smpl 1962 2012 

p_m(1)=2.0
equation _eq_m.ls(p) dlog(m)=p_m(1)*dlog(td)+c_m(2)*log(compm)+c_m(3)*log(q/cap)+c_m(4)+c_m(5)*log(m(-1)/td(-1))+m_ec'+c_m(6)*(t-2012)*(t<=2012)+m_ec
'_mod_afs.append dlog(m)=p_m(1)*dlog(td)+c_m(2)*log(compm)+c_m(3)*log(q/cap)+c_m(4)+c_m(5)*log(m(-1)/td(-1))+m_ec'+c_m(6)*(t-2012)*(t<=2012)+m_ec
_mod_afs.merge _eq_m
genr m_ec=resid 




'    ----------------------------------------------------------

'    estimating exports

'showerr_x
coef(10) c_x
vector(10) p_x
smpl 1962 2012
genr x_ec=0
smpl 1962 2012 

p_x(3)=0

equation _eq_x.ls(p) dlog(x)=c_x(1)*dlog(wd)+c_x(2)*(log(x(-1)/wd(-1))-c_x(4)*log(compx(-1)))+c_x(4)*dlog(compx)+c_x(5)+c_x(6)*(t-2012)*(t<=2012)+x_ec
'_mod_afs.append dlog(x)=c_x(1)*dlog(wd)+c_x(2)*(log(x(-1)/wd(-1))-c_x(4)*log(compx(-1)))+c_x(4)*dlog(compx)+c_x(5)+c_x(6)*(t-2012)*(t<=2012)+x_ec
_mod_afs.merge _eq_x
genr x_ec=resid 

'   ==============================================

'    creating the model

'   ==============================================

'      scalars

scalar f
scalar r_vat0=a_r_vat0
scalar r_tar0=a_r_tar0
scalar r_tarx0=a_r_tarx0

smpl 1962 2012
'==============================
'     production block
'==============================

_mod_afs.append GDPM=FD+X-M
_mod_afs.append Q=GDPM-r_vat0*FD/(1+r_vat0)

'mod_afs.merge _eq_cap
_mod_afs.append UR=Q/CAP
'_mod_afs.append log(lpt)=p_lpt(1)+p_lpt(2)*(t-2012)*(t<=2012)+log((1+txq)/(1+txn))*(t-2012)*(t>=2012) 
_mod_afs.append lfd=q/lpt
'mod_afs.merge _eq_lf
_mod_afs.append lw=lf*r_lw
_mod_afs.append LT=LF+lg 
_mod_afs.append lp=Q/LF 
'mod_afs.merge _eq_ip
_mod_afs.append k=k(-1)*(1-rdep)+ip 
'mod_afs.merge _eq_ic
'mod_afs.merge _eq_popac
_mod_afs.append UN=POPAC-LT
_mod_afs.append UNR=UN/POPAC*100

'    price block

_mod_afs.append COSTW=WR*(1+r_scf)/LP  
'mod_afs.merge _eq_pq
_mod_afs.append PP=(PQ+tc*PFDXT)/(1+tc)
genr (1+res_fdv)*(coh*pcoh+ip*pip+ih*pip+ic*pfd+cog*pcog+pig*ig)=fdv
_mod_afs.append FDV=(1+res_fdv)*(coh*pcoh+ip*pip+ih*pip+ic*pfd+cog*pcog+pig*ig)
_mod_afs.append FDLV=GDPMV-XV
_mod_afs.append FDL=GDPM-X
_mod_afs.append PFDL=FDLV/FDL
genr FDLV=GDPMV-XV
genr FDL=GDPM-X
genr PFDL=FDLV/FDL
genr PFD1=PFDL*(FD-M)/FD 
genr PFD2=PM*M/FD
'_mod_afs.append PFD1=PFDL*(FD-M)/FD 
'_mod_afs.append PFD2=PM*M/FD
_mod_afs.append PFD=(FDLV+MV)/(FDL+M)
_mod_afs.append PFDXT=PFD*(1+r_vat0)/(1+r_vat) 
_mod_afs.append pcoh=r_pcoh*PFD
_mod_afs.append pip=r_pip*PFD
_mod_afs.append PIG=r_pig*PFD 
'mod_afs.merge _eq_wr
_mod_afs.append cost=(wr*lf*(1+r_scf)+c_cost*pip*k(-1))/q
'mod_afs.merge _eq_px
'mod_afs.merge _eq_pm
scalar c_er=1
_mod_afs.append dlog(ER)=(c_er=1)*dlog(erx)+(c_er=2)*dlog(pcoh)
scalar c_irs=2
_mod_afs.append IRS=(c_irs=1)*IRSX+(c_IRS=2)*(IRSR+100*@pchy(pcoh))+(c_IRS=3)*(150*@pchy(pcoh)+50*(q/cap-urd)/urd+irst)
_mod_afs.append IRL=@movav(IRS,4)+IRL_ER
genr irl_er=(IRL-@movav(IRS,4))
scalar c_ir=0.5
_mod_afs.append IR=c_ir*IRS+(1-c_ir)*IRL+ir_eR
genr ir_er=IR-(c_ir*IRS+(1-c_ir)*IRL)
scalar c_irm=0.8
_mod_afs.append IRM=c_irm*IRM(-1)+(1-c_irm)*IR
_mod_afs.append relc=wr*(1+r_scf)/pip/(ir/100-@pchy(pcoh)+rdep)

'   households block

_mod_afs.append REM=REMX*ER
_mod_afs.append REVX=r_revx*PFD
_mod_afs.append SOCB=socbr*pcoh*popt
_mod_afs.append WageG=WR*lg
_mod_afs.append Wage=WageF+WageG
_mod_afs.append SCW=r_scw*Wage
_mod_afs.append HI=Wage-SCW+REVQ+REVX+SOCB+rem
_mod_afs.append ICT=r_ict*HI   '  *****rem : lagged???
_mod_afs.append HDI=HI-ICT
_mod_afs.append HRDI=HDI/pcoh
_mod_afs.append IH=R_IH*HRDI
'mod_afs.merge _eq_coh

'    firms block

_mod_afs.append Qv=PQ*Q
_mod_afs.append GDPMv=Qv+VAT
_mod_afs.append pgdpm=GDPMv/GDPM
_mod_afs.append WageF=WR*lw
_mod_afs.append SUBS=r_subs*Qv
_mod_afs.append MARG=PQ*Q*(1+r_subs-r_oit)-Wagef*(1+r_scf)
_mod_afs.append RMARG=MARG/Qv
_mod_afs.append IFP=(marg-revq)*r_ifp
_mod_afs.append NIF=NIF(-1)*IRM/IRM(-1)-IR/100*FCAPF+nif_er*qv
_mod_afs.append REVQ=R_REVQ*QV
_mod_afs.append PROF=MARG-REVQ-IFP-NIF
_mod_afs.append RPROF=PROF/(PFD*K(-1))
_mod_afs.append RPROB=MARG/(PFD*K(-1))
_mod_afs.append FCAPF=PROF-pip*I-PFD*IC
_mod_afs.append I=IP+IH+IG

'     external trade block

_mod_afs.append PMT=PM*(1+r_tar)/(1+r_tar0)
_mod_afs.append COMPM=PMT/PP 
_mod_afs.append FD=COH+IP+IH+IC+cog+IG+fdxr*Q
_mod_afs.append CI=TC*Q
_mod_afs.append TD=FD+CI
'mod_afs.merge _eq_m
_mod_afs.append COMPX=PX*(1+r_tarx)/(1+r_tarx0)/(PPX*ER)
'_mod_afs.merge _eq_x
_mod_afs.append Mv=PM*M
_mod_afs.append Xv=PX*X
_mod_afs.append RCval=Xv/Mv
_mod_afs.append RCVOL=X/M
_mod_afs.append TTRAD=PX/PM
_mod_afs.append TRB=Xv-Mv
scalar c_nix=0.5
_mod_afs.append NIXD=NIXD(-1)*IRM/IRM(-1)-IR/100*c_nix*TRB+nixd_ec*(xv+mv)
_mod_afs.append NIXX=NIXX(-1)*IRMX/IRMX(-1)*(er/er(-1))-IRX/100*((1-c_nix)*TRB) +nixx_ec*(xv+mv)
_mod_afs.append NIX=NIXD+NIXX
_mod_afs.append FCAPX=TRB-NIX
'
'     State budget block
'
_mod_afs.append VAT=r_vat*PFD*FD/(1+r_vat)
_mod_afs.append SCF=r_scf*Wagef
_mod_afs.append OIT=r_oit*(Qv-oit)
_mod_afs.append TAR=r_tar*Mv
_mod_afs.append Scg=R_Scg*WAGEG
_mod_afs.append REVG=SCF+Scg+SCW+OIT+IFP+ICT+VAT+TAR+r_revg*Qv
_mod_afs.append IGV=IG*PIG
_mod_afs.append PCOG=PFD*R_PCOG
_mod_afs.append cogV=cog*Pcog
_mod_afs.append FDGV=cogV+IGV
_mod_afs.append NIG=NIG(-1)*IRM/IRM(-1)-IR/100*FCAPG+nig_er*qv
_mod_afs.append EXPG=FDGV+WAGEG+SUBS+SOCB+NIG+Scg+r_expg*Qv
_mod_afs.append FCAPG=REVG-EXPG
_mod_afs.append FCAPGP=100*FCAPG/gdpmv

'     We check the residuals

_mod_afs.append assign @all _c

smpl 2000 2012


_mod_afs.makegroup(a,n) _g_vendog @endog
_mod_afs.makegroup(a,n) _g_vexog @exog
_mod_afs.makegroup(a,n) _g_viden @endog
group _g_vbeha

for !i=1 to _g_vendog.@count
%1=_g_vendog.@seriesname(!i)
scalar  {%1}_is=@isobject(%1+"_ec")
if  {%1}_is=1 then
_g_vbeha.add {%1}
_g_viden.drop {%1}
endif
next

pagestruct(end=2100) * 

'     We define long-term growth rates 
'     Actually they will be applied to Dlogs (the same to the first order)
'     as we shall see later


scalar txq=0.035
scalar txn=0.01
scalar txp=0.050

'========================================
'       Changing elements in estimated equations
'========================================

'      We will 'showhow to modify equations
'      taking the example of capital

'    We will do it also for the value added deflator, the wage rate, imports and exports

'      First we estimate the equation as usual
'      but we add a "1" to its usual name

'smpl 1962 2004
'genr k_ec=0
'smpl 1962 2003
'equation _eq_k1.ls(p) dlog(k)=c_k(1)*dlog(k(-1))+0.50*c_k(2)*(q-q(-4))/q(-4)-c_k(2)*(urd-q/cap)/(q/cap)+c_k(4)*@movav(rprob,3)+c_k(5)*((t-2013)*(t<=2013))+c_k(6)   +k_ec 

'    Now we create a vector of parameters
'    equiVent to the vector of coefficients
'    but with "p" instead of "c"

'vector(10) p_k

'     We transfer the estimated values except the constant

'p_k(1)=c_k(1)
'p_k(2)=c_k(2)
'p_k(3)=c_k(2)
'p_k(4)=c_k(4)
'p_k(5)=c_k(5)

'      We reproduce the equation
'       with the original name
'       but some coefficients are replaced by vector elements
'       (not the constant)

'      We estimate the equation and compute the residual

'       As written, the simulated equation will work in the same way as before
'       but we can fix the value of any set of coefficients
'       by replacing "c" by "p" and giving a value as above
'       the remaining coefficients will be estimated

'       This can apply to one or several coefficients
'        but not to the constant
'        as EViews requires at least one coefficient to estimate

'equation _eq_k.ls(p) dlog(k)=p_k(1)*dlog(k(-1))+0.50*p_k(2)*(q-q(-4))/q(-4)-p_k(2)*(urd-q/cap)/(q/cap)+p_k(4)*@movav(rprob,3)+p_k(5)*((t-2013)*(t<=2013))+c_k(6)+k_ec 
'genr k_ec=resid

'       Forecasting the residuals for 2004 is done as usual

'for !i=1 to 4
'smpl 2004 2004 if (t=2004+(!i-1)/4)
'_eq_k.forecast(d) _z
'genr k_ec=dlog(k)-_z
'next
'_mod_afs.merge _eq_k 

'==========================================================
'     Setting the assumptions for the exogenous
'==========================================================

'      The above values will be applied to the Dlogs 
'       instead of being used as growth rates 

'       The reason quite technical (we are in a study phase)
'        It makes it easier to observe convergence to a steady state path 
'        (in particular visually)
'        if the dimension of the variable is a combination of basic ones
'        for instance for values (price+quantity) and wage rates (price+quantity-population)

'        A combination of "round" dlogs is a round dlog
'        which is not exactly true for growth rates

'        However for actual forecasts one can prefer reverting to growth rates
'        One just has to replace "dlog" by "@pch" 
'        in the following formulas

	'   Constant values : Dlog=0

smpl @all 

smpl 2013 2050
for %1 COH_EC ERX FDXR  K_EC CI_EC IR_ER IRL_ER IRMX IRSR IRST IRSX IRX LF_EC  M_EC NIF_ER NIG_ER PK PM_EC POPAC_EC PQ_EC PX_EC R_EXPG R_ICT R_IFP R_OIT R_PCOH R_PCOG R_PI R_PIG R_REVG R_REVQ R_SCF R_SCG R_SCW R_SUBS R_TAR R_TARX R_VAT RDEP TC URD  WR_EC X_EC IRM_ER NIXD_EC NIXX_EC R_IH R_LW R_PIP IC_EC IP_EC fcapf_er prof_er res_fdv
genr {%1}={%1}(-1)
next

	'  Variables at constant prices : Dlog=txq

for %1  COG   IG   R_REVX  
genr {%1}={%1}(-1)*(1+txq)
next

'    Special case for world demand 

genr wd=wd(-1)*(1+txq)

	'  Populations : Dlog=txn

for %1 LG POP1564 POP
genr {%1}={%1}(-1)*(1+txn)
next

	'  Prices : Dlog=txp

for %1  PPX 
genr {%1}={%1}(-1)*(1+txp)
next

	'  Values : Dlog=txp+txq

for %1  REMX 
genr {%1}={%1}(-1)*(1+txp)*(1+txq)
next

'            Purchasing power per head : Dlog=txp-txn

for %1   SOCBR
genr {%1}={%1}(-1)*(1+txq)/(1+txn)
next

'            The time trend

genr t=t(-1)+1

'             Now we give values to the endogenous
'             There are two main reasons

'             1 - This gives an alternate starting point for the solution algorithms
'              Sometimes this starting point is more efficient
'              One can just check

'             2 - This allows to make a residual check on the future
'              which is useful to check that :
'              using the exogenous assumptions 
'              applying the formula provides a steady state path
'              with the same growth rate as the variable it computes

'              When the condition is met for all equations
'              a steady state path exists
'              and will be reached provided the process is converging

'              A difference can come from :
'              - wrong dimensions in the assumptions
'              - non homogenous formulas
'              - wrong initialization of endogenous (not a real problem)

smpl 2013 2050
 
'        Constant values : Dlog=0

for %1   COMPM COMPX ER  FCAPGP IR IRL IRM IRS RCVAL RCVOL RES_WR  RMARG RPROB RPROF TTRAD UNR  UR
genr {%1}={%1}(-1)
next

'       Variables at constant prices : Dlog=txq

for %1  CAP COH  FD HRDI I IP IH CI K  M  Q  X GDPM IC TD FDL
genr {%1}={%1}(-1)*(1+txq)
next

'       Populations : Dlog=txn

for %1 LFD  LF LW LS LT   POPAC UN  popt
genr {%1}={%1}(-1)*(1+txn)
next

'      Deflators : Dlog = txp

for %1    COST PCOG PCOH PFD PFDXT PPI PIG PM PMT  PP PQ PX UWC PGDPM PIP COSTW PFDL
genr {%1}={%1}(-1)*(1+txp) 
next

'       Variables at current prices : Dlog = txp+txq

for %1 COGV  EXPG FCAPF FCAPG FCAPX FDGV HDI HI ICT IFP IGV MARG MV NIF NIG NIX NIXL NIXX OIT PROF GDPMV QV  REVG REVQ REVX  SCF SCG SCW SOCB SUBS TAR TRB  VAT XV  NIXD WAGE WAGEF WAGEG REM FDV FDLV
genr {%1}={%1}(-1)*(1+txp)*(1+txq)
next

'       Variables at current prices  per head : Dlog=txp+txq-txn

for %1 WR  
genr {%1}={%1}(-1)*(1+txp)*(1+txq)/(1+txn)
next

'      Variables at constant prices  per head : Dlog=txp+txq-txn

for %1 LP LPT RELC
genr {%1}={%1}(-1)*(1+txq)/(1+txn)
next   

save model_afs


