
'        This program transfers the  data for South Africa to EViews
'        The data comes from the World bank and the International Labor Organization

'        We define the directory

cd "c:\users\jean louis brillet\documents\eviews\book_africa2\afsud"

'        We close the file in case it exists

close data_afs

'        We create a data file fior the World Bank series

wfcreate(wf=data_afs,page=wb,t) a 1960 2020

'         We delete all preexisting series

delete *

'         We read south african data from an Excel file called "afsud_wb" with a page named "wb"

smpl 1960 2013
read(t=xls,e2,s=data,t) afsud_wb.xls 1300

'         We read World data from an Excel file called "world_wb" with a page named "wb"

smpl 1960 2013
read(t=xls,e2,s=data,t) world_wb.xls 3

'        We create a group for the original series

group g_wb *

'        We drop the "resid" series

g_wb.drop resid

'       We save the first version of the workfile

wfsave data_afs

'       Now we treat the ILO data

'       We delete the page in case it exists

pagedelete ilo

'      It will run from 1974 to 2012

pagecreate(page=ilo) a 1974 2012

'      The format is very special
'      Series are organized by year
'      We have only one observation by line
'      and the number of series varies with each year

'      Example

'      From 1974 to 1979 we have 8 series

'    We start counting the lines

!j=1
for !i=1974 to 1979

'     We establish the sample

smpl !i !i 

'      We read the 8 values in column E

read(type=excel,t,e{!j},,s=data) w_afs.xls 8

'      We increment the line counter by 8
 
!j=!j+8
next    

'      We move to the next set of periods

for !i=1980 to 1992
smpl !i !i 
read(e{!j}, type=excel,t,s=data) w_afs.xls 13 
!j=!j+13
next 

for !i=1993 to 1993
smpl !i !i 
read(e{!j}, type=excel,t,s=data) w_afs.xls 9 
!j=!j+9
next 

for !i=1994 to 2002
smpl !i !i 
read(e{!j}, type=excel,t,s=data) w_afs.xls 16 
!j=!j+16
next

for !i=2005 to 2005
smpl !i !i 
read(e{!j}, type=excel,t,s=data) w_afs.xls 16 
!j=!j+16
next

for !i=2006 to 2006
smpl !i !i 
read(e{!j}, type=excel,t,s=data) w_afs.xls 15 
!j=!j+15
next

for !i=2007 to 2008
smpl !i !i 
read(e{!j}, type=excel,t,s=data) w_afs.xls 16 
!j=!j+16
next

for !i=2009 to 2010
smpl !i !i 
read(e{!j}, type=excel,t,s=data) w_afs.xls 19 
!j=!j+19
next

for !i=2011 to 2012
smpl !i !i 
read(e{!j}, type=excel,t,s=data) w_afs.xls 9 
!j=!j+9
next

'    We deine a group for all series
'     except for resid

group g_ilo *
g_ilo.drop resid

'     We save the file again

wfsave data_afs


